use32
    org 0x0
    db  'MENUET01'
    dd  0x01,start,i_end,e_end,e_end,0,0

include 'proc32.inc'
include 'macros.inc'
include 'snd.inc'
include 'snd_const.inc'
include 'sound.asm'

__DEBUG__ = 1
__DEBUG_LEVEL__ = 1
include 'debug-fdo.inc'

struct F70
  subfunc  dd 1
  offset_l dd 1
  offset_h dd 1
  count    dd 1
  dest     dd 1
  flag     db 1
  filename dd 1
ends

start:
        mcall   68, 11
still:
        mcall   10
        dec     eax
        jz      redraw
        dec     eax
        jz      key

button:
        mcall   17
        shr     eax, 8

        cmp     eax, 1
        jz      quit
        cmp     eax, 0xabc1
        jnz     @f
        stdcall load_play_file, file_c
        jmp     still
    @@:
        cmp     eax, 0xabc2
        jnz     @f
        stdcall load_play_file, file_e
        jmp     still
    @@:
        cmp     eax, 0xabc3
        jnz     @f
        stdcall load_play_file, file_g
        jmp     still
    @@:
        jmp     still

redraw:
        mcall   12, 1
        mcall   0, <300,315>, <300,184>, 0x34dddddd, 0, window_title

        mcall   8,  <50,50>, <50,50>, 0xabc1, 0xffdddd
        mcall   8, <120,50>, <50,50>, 0xabc2, 0xddffdd
        mcall   8, <190,50>, <50,50>, 0xabc3, 0xddddff

        mcall   12, 2
        jmp     still

key:
        mcall   2
;        cmp     ah, 
        jmp     still

quit:
        mcall   -1


proc load_file _filename
       	mov	[f70.subfunc], 5
	mov	[f70.dest], fileinfo
	mov	byte[f70.flag], 0
        mov     eax, [_filename]
	mov	[f70.filename], eax
	mcall	70, f70
	test	eax, eax
	jnz	.error

	mcall	68, 12, dword[fileinfo.Size]
	test	eax, eax
	mov	[raw_file_data], eax
	jz	.error

	mov	[f70.subfunc], 0		; file read
	mov	[f70.offset_l], 0
	mov	[f70.offset_h], 0
	mov	eax, dword[fileinfo.Size]
	mov	[f70.count], eax
	mov	eax, [raw_file_data]
	mov	[f70.dest], eax
	mcall	70, f70
	test	eax, eax
	jnz	.error
        ret
  .error:
        xor     eax, eax
        inc     eax
        ret
endp


proc load_play_file _filename
	stdcall	_InitSound@4, retvalue
        stdcall load_file, [_filename]
	stdcall	_CreateBuffer@12, PCM_STATIC + PCM_1_16_48, 48000, retvalue
	stdcall	_SetBuffer@16, [retvalue], [raw_file_data], 0, 48000
	stdcall	_PlayBuffer@8, [retvalue], 0
DEBUGF 1, 'Playing %s...\n', [_filename]
        ret
endp


window_title    db 'forte v0.0',0
file_c  db '/hd0/1/c262.raw',0
file_e  db '/hd0/1/e330.raw',0
file_g  db '/hd0/1/g392.raw',0
include_debug_strings

i_end:
retvalue dd ?
raw_file_data dd ?
f70     F70
fileinfo        FILEINFO
rb 0x200        ; stack
e_end:
